## openj9-21 0.53.0

=== debian/changelog ===
openj9-21 (0.53.0-1) unstable; urgency=medium

  * Upgrade upstream

 -- Mathieu Baudier <mbaudier@argeo.org>  Thu, 07 Aug 2025 14:03:02 +0000
